module.exports = {
  "blue-base": "#1890ff;@kd-prefix:kd",
  "theme-color": "#5582f3",
  "hsv-h": "hsvhue(@theme-color)",
  "hsv-s": "hsvsaturation(@theme-color)",
  "hsv-v": "hsvvalue(@theme-color)",
  "theme-color-disabled": "hsv(@hsv-h, max(5%, (@hsv-s - 54%)), min((@hsv-v + 24%), 100%))",
  "theme-color-hover": "hsv(@hsv-h, max(5%, (@hsv-s - 18%)), min((@hsv-v + 8%), 100%))",
  "theme-color-click": "hsv(@hsv-h, min((@hsv-s + 8%), 100%), max(5%, (@hsv-v - 16%)))",
  "theme-color-active-light": "hsv(@hsv-h, max(5%, (@hsv-s - 90%)), min((@hsv-v + 40%), 100%))",
  "theme-color-active-dark": "@theme-color",
  "hover-color": "#f5f5f5",
  "disabled-contain-bg": "#f5f5f5",
  "success-color": "#1ba854",
  "success-bg-color": "#f2fff5",
  "success-border-color": "#6dd18e",
  "warning-color": "#ff991c",
  "warning-bg-color": "#fffbf2",
  "warning-border-color": "#ffcb78",
  "error-color": "#fb2323",
  "error-bg-color": "#fff2f4",
  "error-border-color": "#ff8088",
  "ongoing-color": "#276ff5",
  "ongoing-bg-color": "#f2f9ff",
  "ongoing-border-color": "#85b8ff",
  "disabled-color": "#b2b2b2",
  "disabled-border-color": "#ccc",
  "end-color": "#666",
  "link-color": "#0e5fd8",
  "link-color-hover": "#3987ed",
  "link-color-active": "#0041b0",
  "primary-text-color": "#212121",
  "primary-text-color2": "rgba(255, 255, 255, 1)",
  "secondary-text-color": "#666",
  "secondary-text-color2": "rgba(255, 255, 255, 0.65)",
  "third-text-color": "#999",
  "third-text-color2": "rgba(255, 255, 255, 0.4)",
  "placeholder-text-color": "#ccc",
  "placeholder-text-color2": "rgba(255, 255, 255, 0.3)",
  "bg": "#fff",
  "bg2": "#f2f2f2",
  "contain-bg": "#fafafa",
  "radius-size": "2px",
  "input-color": "#999",
  "strong-border-color": "#d9d9d9",
  "strong-border-color-1": "#d9d9d9",
  "weak-border-color": "#e5e5e5",
  "white": "#fff",
  "dirList": "left, top, bottom, right",
  "font-size": "14px",
  "font-weight": "400",
  "small-font-size": "12px",
  "middle-font-size": "14px",
  "large-font-size": "16px",
  "xlarge-font-size": "18px",
  "zIndex-below": "-1",
  "zIndex-popper": "1000",
  "zIndex-dialog": "1050",
  "zIndex-masker": "3000",
  "zIndex-apex": "9999",
  "transition-duration": "0.3s",
  "btn-border-width": "1px",
  "btn-border-style": "solid",
  "btn-primary-font-color": "@white",
  "btn-primary-background-color": "@theme-color",
  "btn-primary-border-color": "@theme-color",
  "btn-ghost-font-color": "@secondary-text-color",
  "btn-ghost-background-color": "transparent",
  "btn-ghost-border-color": "@strong-border-color",
  "btn-second-font-color": "fade(@secondary-text-color, 65%)",
  "btn-second-background-color": "fade(@white, 65%)",
  "btn-second-border-color": "fade(@strong-border-color, 65%)",
  "btn-link-font-color": "@link-color",
  "btn-disabled-font-color": "@white",
  "btn-disabled-background-color": "@disabled-contain-bg",
  "btn-disabled-border-color": "@strong-border-color",
  "btn-danger-font-color": "@white",
  "btn-danger-background-color": "@error-color",
  "btn-danger-border-color": "@error-color",
  "btn-small-font-size": "@small-font-size",
  "btn-small-height": "24px",
  "btn-small-min-width": "60px",
  "btn-small-padding-vertical": "3px",
  "btn-small-padding-horizontal": "8px",
  "btn-middle-font-size": "@small-font-size",
  "btn-middle-height": "28px",
  "btn-middle-min-width": "60px",
  "btn-middle-padding-vertical": "5px",
  "btn-middle-padding-horizontal": "8px",
  "btn-large-font-size": "@large-font-size",
  "btn-large-height": "32px",
  "btn-large-min-width": "80px",
  "btn-large-padding-vertical": "6px",
  "btn-large-padding-horizontal": "8px",
  "btn-transition-fn": "cubic-bezier(0.075, 0.82, 0.165, 1)",
  "collapse-border-width": "1px",
  "collapse-border-color": "@strong-border-color-1",
  "collapse-icon-margin-right": "6px",
  "collapse-header-font-color": "@primary-text-color",
  "collapse-header-font-size": "@font-size",
  "collapse-content-font-color": "@primary-text-color",
  "collapse-content-font-size": "@font-size",
  "collapse-content-padding": "10px 0px 0px 20px",
  "collapse-disabled-color": "@disabled-color",
  "switch-small-font-size": "@small-font-size",
  "switch-small-line-height": "14px",
  "switch-small-height": "14px",
  "switch-small-min-width": "28px",
  "switch-small-border-radius": "7px",
  "switch-large-font-size": "@small-font-size",
  "switch-large-line-height": "20px",
  "switch-large-height": "20px",
  "switch-large-min-width": "40px",
  "switch-large-border-radius": "10px",
  "switch-on-color": "@theme-color",
  "switch-off-color": "#999",
  "switch-disabled-bg": "@disabled-color",
  "switch-loading-color": "@ongoing-color",
  "switch-font-color": "@white",
  "switch-inner-small-font-size": "@small-font-size",
  "switch-inner-margin": "0 5px 0 16px",
  "switch-inner-checked-margin": "0 16px 0 5px",
  "switch-inner-large-margin": "0 5px 0 21px",
  "switch-inner-large-checked-margin": "0 21px 0 5px",
  "input-placeholder-color": "@third-text-color",
  "input-font-color": "@secondary-text-color",
  "input-focus-color": "@primary-text-color",
  "input-background-color": "@white",
  "input-border-width": "1px",
  "input-width": "230px",
  "input-small-font-size": "@small-font-size",
  "input-small-height": "20px",
  "input-small-padding-vertical": "3px",
  "input-small-padding-horizontal": "9px",
  "input-middle-font-size": "@middle-font-size",
  "input-middle-height": "30px",
  "input-middle-padding-vertical": "5px",
  "input-middle-padding-horizontal": "9px",
  "input-large-font-size": "@large-font-size",
  "input-large-height": "36px",
  "input-large-padding-vertical": "8px",
  "input-large-padding-horizontal": "9px",
  "inputNumber-embedStepBtn-bg-color": "#f6f7f9",
  "checkbox-font-size": "@small-font-size",
  "checkbox-font-color": "@primary-text-color",
  "checkbox-border-color": "@strong-border-color",
  "checkbox-checked-border-color": "@theme-color-active-dark",
  "checkbox-checked-font-color": "@theme-color-active-dark",
  "checkbox-bg-color": "@bg",
  "checkbox-disabled-bg-color": "@disabled-color",
  "checkbox-small-size-height": "32px",
  "checkbox-middle-size-height": "36px",
  "checkbox-large-size-height": "40px",
  "checkbox-border-width": "1px",
  "checkbox-group-margin-right": "8px",
  "checkbox-default-padding": "0",
  "checkbox-default-input-margin-right": "8px",
  "checkbox-default-input-height": "16px",
  "checkbox-default-input-width": "16px",
  "checkbox-default-input-border-radius": "4px",
  "checkbox-default-input-border-width": "1px",
  "checkbox-default-input-icon-color": "#fff",
  "checkbox-default-input-icon-size": "12px",
  "checkbox-square-padding": "0 20px",
  "checkbox-square-triangle-height": "18px",
  "checkbox-square-triangle-width": "18px",
  "checkbox-square-input-icon-color": "#fff",
  "checkbox-square-input-icon-size": "9px",
  "radio-font-size": "@small-font-size",
  "radio-font-color": "@primary-text-color",
  "radio-border-width": "1px",
  "radio-margin-right": "8px",
  "radio-transition-fn": "cubic-bezier(0.075, 0.82, 0.165, 1)",
  "radio-circle-size": "13px",
  "radio-square-height": "32px",
  "radio-square-padding": "0 20px",
  "radio-button-height": "24px",
  "radio-button-padding": "0 18px",
  "icon-css-prefix": "kdicon",
  "popconfirm-icon-size": "17px",
  "popconfirm-min-width": "164px",
  "popconfirm-max-width": "500px",
  "popconfirm-min-height": "98px",
  "popconfirm-max-height": "400px",
  "popconfirm-title-line-height": "21px",
  "popconfirm-color": "@primary-text-color",
  "popconfirm-font-size": "@small-font-size",
  "popconfirm-title-font-size": "@middle-font-size",
  "popconfirm-vertical-gap": "16px",
  "popconfirm-horizontal-gap": "16px",
  "popconfirm-background-color": "@white",
  "popconfirm-box-shadow-blur": "6px",
  "popconfirm-transition-fn": "cubic-bezier(0.25, 1, 0.5, 1)",
  "popconfirm-duration": "0.2s",
  "popover-min-width": "164px",
  "popover-max-width": "500px",
  "popover-min-height": "98px",
  "popover-max-height": "400px",
  "popover-title-line-height": "21px",
  "popover-color": "@primary-text-color",
  "popover-font-size": "@small-font-size",
  "popover-title-font-size": "@middle-font-size",
  "popover-vertical-gap": "16px",
  "popover-horizontal-gap": "16px",
  "popover-background-color": "@white",
  "popover-box-shadow-blur": "6px",
  "popover-transition-fn": "cubic-bezier(0.25, 1, 0.5, 1)",
  "popover-duration": "0.2s",
  "progress-remaining-color": "#e5e5e5",
  "progress-default-color": "@ongoing-color",
  "progress-success-color": "@success-color",
  "progress-failure-color": "@error-color",
  "progress-border-radius": "100px",
  "progress-line-stroke-width": "8px",
  "progress-line-text-width": "3em",
  "progress-line-icon-font-size": "16px",
  "progress-line-text-font-size": "16px",
  "progress-line-special-text-font-size": "16px",
  "progress-line-text-margin-left": "8px",
  "progress-circle-stroke-width": "4px",
  "progress-transition-fn": "cubic-bezier(0.66, 0, 0.34, 1)",
  "progress-circle-text-font-size": "28px",
  "progress-circle-percent-line-height": "48px",
  "progress-circle-unit-line-height": "18px",
  "progress-circle-unit-font-size": "12px",
  "progress-circle-unit-margin-top": "18px",
  "progress-circle-icon-font-size": "48px",
  "pagination-size": "24px",
  "pagination-nicety-size": "30px",
  "pagination-button-gap": "8px",
  "pagination-hover-color": "@theme-color",
  "pagination-font-size": "@small-font-size",
  "pagination-icon-size": "@large-font-size",
  "pagination-font-color": "@secondary-text-color",
  "pagination-button-color": "@secondary-text-color",
  "pagination-button-disabled-color": "@disabled-border-color",
  "pagination-button-disabled-background-color": "@disabled-contain-bg",
  "timeline-width": "1px",
  "timeline-dot-size": "12px",
  "timeline-line-height": "18px",
  "timeline-color": "@weak-border-color",
  "timeline-dot-border-width": "2px",
  "timeline-dot-color": "@theme-color",
  "timeline-dot-bg": "@white",
  "timeline-item-padding-bottom": "26px",
  "tabs-font-color": "@secondary-text-color",
  "tabs-border-color": "@strong-border-color",
  "tabPane-font-size": "@font-size",
  "tabPane-font-color-active": "@theme-color",
  "tabPane-font-color-hover": "@theme-color",
  "tabPane-font-color-disabled": "@disabled-color",
  "tab-line-color-active": "@theme-color",
  "tabs-card-bg": "@disabled-contain-bg",
  "tabs-height": "48px",
  "tabs-border-width": "1px",
  "tab-pane-height": "48px",
  "tab-pane-line-height": "48px",
  "tab-pane-margin-right": "24px",
  "tab-transition-fn": "cubic-bezier(0.42, 0, 1, 1)",
  "select-dropdown-bg": "@bg",
  "select-item-active-bg": "#F5F5F5",
  "select-dropdown-height": "22px",
  "select-list-font-size": "12px",
  "select-large-font-size": "16px",
  "select-middle-font-size": "14px",
  "select-small-font-size": "12px",
  "select-dropdown-line-height": "22px",
  "select-item-selected-color": "#276FF5",
  "select-item-selected-bg": "#F2F9FF",
  "select-font-color": "#212121",
  "select-large-height": "36px",
  "select-middle-height": "30px",
  "select-small-height": "20px",
  "select-large-line-height": "28px",
  "select-middle-line-height": "22px",
  "select-small-line-height": "12px",
  "rate-selected-color": "#fdc200",
  "rate-not-selected-color": "#d9d9d9",
  "rate-icon-margin": "10px",
  "rate-small-font-size": "@small-font-size",
  "rate-middle-font-size": "@middle-font-size",
  "rate-large-font-size": "@large-font-size",
  "dropdown-menu-min-width": "136px",
  "dropdown-menu-max-width": "320px",
  "dropdown-menu-max-height": "336px",
  "dropdown-menu-gap": "8px",
  "dropdown-line-height": "18px",
  "dropdown-color": "@primary-text-color",
  "dropdown-divided-color": "@weak-border-color",
  "dropdown-hover-bg-color": "@disabled-contain-bg",
  "dropdown-active-bg-color": "@theme-color-active-light",
  "dropdown-font-size": "@small-font-size",
  "dropdown-item-vertical-gap": "7px",
  "dropdown-item-horizontal-gap": "12px",
  "dropdown-box-shadow-blur": "10px",
  "dropdown-transition-fn": "cubic-bezier(0.25, 1, 0.5, 1)",
  "dropdown-duration": "0.2s",
  "tooltip-width": "267px",
  "tooltip-line-height": "18px",
  "tooltip-color": "@primary-text-color",
  "tooltip-font-size": "@small-font-size",
  "tooltip-vertical-gap": "8px",
  "tooltip-horizontal-gap": "12px",
  "tooltip-background-color": "@white",
  "tooltip-box-shadow-blur": "6px",
  "transfer-disabled-bg": "@disabled-contain-bg",
  "transfer-border-color": "@strong-border-color",
  "transfer-padding-base": "14px",
  "transfer-font-size-base": "12px",
  "transfer-list-item-height": "32px",
  "transfer-list-content-height": "@transfer-list-item-height * 10",
  "transfer-list-item-hover-bg": "@hover-color",
  "transfer-list-item-checked": "@theme-color",
  "transfer-list-item-disabled": "@disabled-color",
  "transfer-header-bg": "#f5f5f5",
  "transfer-header-height": "36px",
  "transfer-search-height": "32px",
  "transfer-search-prefix-icon-color": "@theme-color",
  "transfer-search-suffix-icon-color": "#bbb",
  "transfer-pagination-height": "36px",
  "success-alert-bg-color": "@success-bg-color",
  "warning-alert-bg-color": "@warning-bg-color",
  "error-alert-bg-color": "@error-bg-color",
  "info-alert-bg-color": "@ongoing-bg-color",
  "alert-transition-fn": "cubic-bezier(0.32, 0.94, 0.6, 1)",
  "split-panel-trigger-border-color": "#ccc",
  "split-panel-trigger-arrow-color": "#a7b5d3",
  "split-panel-trigger-arrow-hover-color": "@theme-color",
  "split-panel-trigger-line-width": "1px",
  "split-panel-trigger-line-color": "@split-panel-trigger-border-color",
  "confirm-modal-title-icon-bg": "@ongoing-bg-color",
  "warning-modal-title-icon-bg": "@warning-bg-color",
  "error-modal-title-icon-bg": "@error-bg-color",
  "steps-transition-fn": "cubic-bezier(0.48, 0.04, 0.52, 0.96)",
  "tag-font-size": "12px",
  "tag-border-radius": "10px",
  "tag-height": "18px",
  "tag-process-color": "@ongoing-color",
  "tag-success-color": "@success-color",
  "tag-warning-color": "@warning-color",
  "tag-error-color": "@error-color",
  "tag-end-color": "@end-color",
  "tag-expired-color": "@disabled-color"
};
