export interface FormatParam {
    mask?: string;
    zeroShow?: boolean;
    decimalLength?: number;
    showDecimalTailZero?: boolean;
    isRound?: boolean;
    symbol?: string;
    code?: string;
}
export interface EditFormatParam {
    zeroShow?: boolean;
    decimalLength?: number;
    showDecimalTailZero?: boolean;
    roundMethod?: string;
    symbol?: string;
}
/**
 * [数值类型格式化]
 * @param  {[type]}  num                              [待格式化的数字]
 * @param  {String}  mask                             [数值掩码
 * 0：必须输入数字（0—9）
 * 9：可选择输入数字（0—9）或空格
 * #：可选择输入数字（0—9） 递归
 * .: 小数点
 * ,: 千位符
 * %: 对最终值除以100处理
 * %%: 对最终值不做处理
 * //A: [a-zA-Z0-9]
 * //S: [a-zA-Z]
 * //&：必须输入任一字符或空格
 * //C：可选择输入任一字符或空格
 * $: 货币
 * ]
 * @param  {Boolean} zeroShow                         [为零显示]
 * @param  {[type]}  decimalLength                    [小数精度的位数]
 * @param  {Boolean} showDecimalTailZero              [是否显示尾部零]
 * @return                                            [格式化后的数值]
 */
export declare function formatNumber(num: string | number, formatParams: FormatParam): string;
/**
 * 格式化数字字段编辑态的值
 * 不支持掩码的格式化信息
 * @param {*} num
 * @param {*} param
 */
export declare function formatEditNumber(num: number | string, { zeroShow, decimalLength, showDecimalTailZero, roundMethod, symbol }: EditFormatParam): string;
