import _taggedTemplateLiteral from "@babel/runtime-corejs3/helpers/taggedTemplateLiteral";

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5;

import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import styled, { css } from 'styled-components';
export var LOCK_SHADOW_PADDING = 20;
var prefix = 'kd-';
export var Classes = {
  /** BaseTable 表格组件的外层包裹 div */
  artTableWrapper: "".concat(prefix, "table-wrapper"),
  artTableBordered: "".concat(prefix, "table-bordered"),
  artTable: "".concat(prefix, "table"),
  tableHeaderMain: "".concat(prefix, "table-header-main"),
  tableHeader: "".concat(prefix, "table-header"),
  tableBody: "".concat(prefix, "table-body"),
  virtual: "".concat(prefix, "virtual"),
  tableFooter: "".concat(prefix, "table-footer"),
  tableFooterMain: "".concat(prefix, "table-footer-main"),

  /** 表格行 */
  tableRow: "".concat(prefix, "table-row"),

  /** 表头行 */
  tableHeaderRow: "".concat(prefix, "table-header-row"),

  /** 单元格 */
  tableCell: "".concat(prefix, "table-cell"),

  /** 表头的单元格 */
  tableHeaderCell: "".concat(prefix, "table-header-cell"),
  tableHeaderCellContent: "".concat(prefix, "table-header-cell-content"),
  tableHeaderCellResize: "".concat(prefix, "table-header-cell-resize"),
  virtualBlank: "".concat(prefix, "virtual-blank"),
  stickyScroll: "".concat(prefix, "sticky-scroll"),
  stickyScrollItem: "".concat(prefix, "sticky-scroll-item"),
  horizontalScrollContainer: "".concat(prefix, "horizontal-scroll-container"),
  verticalScrollPlaceholder: "".concat(prefix, "vertical-scroll-placeholder"),
  horizontalStickyScrollContainer: "".concat(prefix, "horizontal-sticky-scroll-container"),
  horizontalScrollLeftSpacer: "".concat(prefix, "horizontal-scroll-left-spacer"),
  horizontalScrollRightSpacer: "".concat(prefix, "horizontal-scroll-right-spacer"),
  lockShadowMask: "".concat(prefix, "lock-shadow-mask"),
  lockShadow: "".concat(prefix, "lock-shadow"),
  leftLockShadow: "".concat(prefix, "left-lock-shadow"),
  rightLockShadow: "".concat(prefix, "right-lock-shadow"),

  /** 数据为空时表格内容的外层 div */
  emptyWrapper: "".concat(prefix, "empty-wrapper"),
  loadingWrapper: "".concat(prefix, "loading-wrapper"),
  loadingContentWrapper: "".concat(prefix, "loading-content-wrapper"),
  loadingIndicatorWrapper: "".concat(prefix, "loading-indicator-wrapper"),
  loadingIndicator: "".concat(prefix, "loading-indicator"),
  tableHeaderCellLine: "".concat(prefix, "table-header-cell-line"),
  tableFilterTrigger: "".concat(prefix, "filter-trigger"),
  tableSortIcon: "".concat(prefix, "sort-icon"),
  tableExtendIcon: "".concat(prefix, "extend-icon"),
  button: "".concat(prefix, "btn"),
  buttonPrimary: "".concat(prefix, "btn-primary"),
  filterIcon: "".concat(prefix, "filter-icon"),
  rangeSelection: "".concat(prefix, "range-selection"),
  tableCellRangeSingleCell: "".concat(prefix, "table-cell-range-single-cell"),
  tableCellRangeSelected: "".concat(prefix, "table-cell-range-selected"),
  tableCellRangeTop: "".concat(prefix, "table-cell-range-top"),
  tableCellRangeLeft: "".concat(prefix, "table-cell-range-left"),
  tableCellRangeBottom: "".concat(prefix, "table-cell-range-bottom"),
  tableCellRangeRight: "".concat(prefix, "table-cell-range-right"),
  fixedLeft: "".concat(prefix, "fixed-left"),
  fixedRight: "".concat(prefix, "fixed-right"),
  rowDetailContainer: "".concat(prefix, "row-detail-container"),
  rowDetailItem: "".concat(prefix, "row-detail-item"),
  emptyColCell: "".concat(prefix, "empty-col-cell"),
  first: "".concat(prefix, "first"),
  last: "".concat(prefix, "last"),
  even: "".concat(prefix, "even"),
  odd: "".concat(prefix, "odd"),
  lockLeft: "".concat(prefix, "lock-left"),
  lockRight: "".concat(prefix, "lock-right"),
  rowSpan: "".concat(prefix, "row-span"),
  leaf: "".concat(prefix, "leaf"),
  expanded: "".concat(prefix, "expanded"),
  collapsed: "".concat(prefix, "collapsed"),
  popup: "".concat(prefix, "popup"),
  popupHeader: "".concat(prefix, "popup-header"),
  popupBody: "".concat(prefix, "popup-body"),
  rowDragging: "".concat(prefix, "row-dragging"),
  rowDragStart: "".concat(prefix, "row-drag-start"),
  rowDragEnd: "".concat(prefix, "row-drag-end"),
  rowDragEndToTop: "".concat(prefix, "row-drag-end-to-top"),
  rowDragEndToBottom: "".concat(prefix, "row-drag-end-to-bottom"),
  rowDragElement: "".concat(prefix, "row-drag-element"),
  rowDragCell: "".concat(prefix, "row-drag-cell")
};
export var MenuClasses = {
  menu: "".concat(prefix, "table-menu"),
  menuList: "".concat(prefix, "table-menu-list"),
  menuOption: "".concat(prefix, "table-menu-option"),
  menuOptionActive: "".concat(prefix, "table-menu-option-active"),
  menuOptionDisable: "".concat(prefix, "table-menu-option-disable"),
  menuOptionText: "".concat(prefix, "table-menu-option-text")
};
var Z = {
  lock: 5,
  header: 15,
  footer: 10,
  lockShadow: 20,
  rowDetail: 25,
  scrollItem: 30,
  loadingIndicator: 40
};
var outerBorderStyleMixin = css(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  border-top: 1px solid #cccccc;\n  border-right: 1px solid #cccccc;\n  border-bottom: 1px solid #cccccc;\n  border-left: 1px solid #cccccc;\n\n  td.", ",\n  th.", " {\n    border-left: none;\n  }\n  td.", ",\n  th.", " {\n    border-right: none;\n  }\n\n  thead tr.", " th,\n  tbody tr.", " td {\n    border-top: none;\n  }\n  &.has-footer tfoot tr.", " td {\n    border-bottom: none;\n  }\n  &:not(.has-footer) tbody tr.", " td {\n    border-bottom: none;\n  }\n  td.", ":not(.", "){\n    border-left: var(---cell-border-vertical);\n  }\n  td.", ":not(.", "){\n    border-right: var(---cell-border-vertical);\n  }\n"])), Classes.first, Classes.first, Classes.last, Classes.last, Classes.first, Classes.first, Classes.last, Classes.last, Classes.rowSpan, Classes.first, Classes.rowSpan, Classes.last);
export var defaultCSSVariables = {
  '--row-height': '48px',
  '--color': '#333',
  '--bgcolor': 'white',
  '--hover-bgcolor': 'var(--hover-color, #f5f5f5)',
  '--highlight-bgcolor': '#eee',
  '--primary-color': '#5582F3',
  '--primary-color-level1': 'rgb(242, 248, 255)',
  '--primary-color-level2': 'rgb(135, 173, 255)',
  '--icon-color': '#666666',
  '--strong-border-color': '#d9d9d9',
  '--header-row-height': '32px',
  '--header-color': '#333',
  '--header-bgcolor': '#f4f4f4',
  '--header-hover-bgcolor': '#ddd',
  '--header-highlight-bgcolor': '#e4e8ed',
  '--cell-padding': '8px 12px',
  '--font-size': '12px',
  '--line-height': '1.28571',
  '--lock-shadow': 'rgba(152, 152, 152, 0.5) 0 0 6px 2px',
  '--border-color': '#dfe3e8',
  '--cell-border': '1px solid #dfe3e8',
  '--cell-border-horizontal': '1px solid #dfe3e8',
  '---cell-border-vertical': '1px solid #dfe3e8',
  '--header-cell-border': '1px solid #dfe3e8',
  '--cell-border-vertical': '1px solid #dfe3e8',
  '--header-cell-border-horizontal': '1px solid #dfe3e8',
  '--header-cell-border-vertical': '1px solid #dfe3e8'
};
export var variableConst = getCssVariableText(defaultCSSVariables);
var notBorderedStyleMixin = css(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  --cell-border-vertical: none;\n  --header-cell-border-vertical: none;\n"])));
var borderedStyleMixin = css(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  //th\u9690\u85CF\u5217\u5BBD\u62D6\u62FD\u7684\u80CC\u666F\u8272\uFF0C\u4F7F\u7528th\u7684\u53F3\u8FB9\u6846\u4EE3\u66FF\n  .", "::after{\n    background-color: inherit;\n  }\n"])), Classes.tableHeaderCellResize);
export var StyledArtTableWrapper = styled.div(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  :root {\n    ", "\n  }\n  ", "\n\n  box-sizing: border-box;\n  * {\n    box-sizing: border-box;\n  }\n  cursor: default;\n  color: var(--color);\n  font-size: var(--font-size);\n  line-height: var(--line-height);\n  position: relative;\n\n  // \u8868\u683C\u5916\u8FB9\u6846\u7531 art-table-wrapper \u63D0\u4F9B\uFF0C\u800C\u4E0D\u662F\u7531\u5355\u5143\u683C\u63D0\u4F9B\n  &.use-outer-border {\n    ", ";\n  }\n\n  // \u8868\u683C\u4E0D\u542F\u7528\u8FB9\u6846\u7EBF\uFF0C\u9690\u85CFth\u3001td\u7684\u5355\u5143\u683C\u5DE6\u53F3\u8FB9\u6846\u7EBF\n  &:not(.", ") {\n    ", "\n  }\n  &.", "{\n    ", "\n  }\n\n  .no-scrollbar {\n    ::-webkit-scrollbar {\n      display: none;\n    }\n  }\n\n  .", " {\n    overflow: auto;\n    flex-shrink: 1;\n    flex-grow: 1;\n    display: flex;\n    flex-direction: column;\n  }\n\n  .", " {\n    overflow: hidden;\n    background: var(--header-bgcolor);\n    display: flex;\n    flex-shrink: 0;\n    border-bottom: var(--header-cell-border-horizontal);\n  }\n\n  .", " {\n    display: flex;\n    // justify-content: flex-start;\n    align-items: center;\n    height: inherit;\n  }\n\n  .", " {\n     overflow-x:auto;\n     flex-shrink: 0;\n     flex-grow: 0;\n     scrollbar-width: none; // \u517C\u5BB9\u706B\u72D0\n     & {\n       ::-webkit-scrollbar {\n         display:none;\n       }\n     }\n   }\n\n  .", " {\n    display: flex;\n    flex: none;\n  }\n  .", ", .", " {\n    background: var(--bgcolor);\n    overflow: auto;\n    overflow-x: hidden;\n    overflow-anchor: none;\n    position:relative;\n    &.empty {\n      position: relative;\n    }\n  }\n\n  .", " {\n    position: relative;\n  }\n  .", ", .", "  {\n    .", "{\n      background-color: #e6effb !important;\n    }\n    .", "{\n      border-top: 1px solid #0E5FD8 !important;\n    }\n    .", "{\n      border-left: 1px solid #0E5FD8 !important;\n    }\n    .", "{\n      border-bottom: 1px solid #0E5FD8 !important;\n    }\n    .", "{\n      border-right: 1px solid #0E5FD8 !important;\n    }\n  }\n\n  .", " {\n    user-select:none;\n  }\n\n  .", " {\n    user-select:none;\n    .", " .", " >td{\n        cursor:move;\n    }\n\n    .", " .", " >td{\n        cursor:no-drop;\n    }\n    \n  }\n\n  .", "{\n    opacity: 0.5;\n  }\n\n\n  .", " td{\n    border-top: 1px solid var(--primary-color) !important;\n  }\n\n  .", " td{\n    border-bottom: 1px solid var(--primary-color) !important;\n   \n  }\n\n  .", " {\n    cursor:pointer;\n  }\n\n\n  &.sticky-header .", " {\n    position: sticky;\n    top: 0;\n    z-index: ", ";\n  }\n\n  &.sticky-footer .", " {\n    position: sticky;\n    bottom: 0;\n    z-index: ", ";\n  }\n\n  table {\n    width: 0;\n    table-layout: fixed;\n    border-collapse: separate;\n    border-spacing: 0;\n    display: table;\n    margin: 0;\n    padding: 0;\n    flex-shrink: 0;\n    flex-grow: 0;\n    position:relative;\n  }\n\n  // \u5728 tr \u4E0A\u8BBE\u7F6E .no-hover \u53EF\u4EE5\u7981\u7528\u9F20\u6807\u60AC\u505C\u6548\u679C\n  tr:not(.no-hover):hover > td {\n    background: var(--hover-bgcolor);\n  }\n  // \u4F7F\u7528 js \u6DFB\u52A0\u60AC\u6D6E\u6548\u679C\n  tr:not(.no-hover).row-hover > td {\n    background: var(--hover-bgcolor);\n  }\n  // \u5728 tr \u8BBE\u7F6E highlight \u53EF\u4EE5\u4E3A\u5E95\u4E0B\u7684 td \u8BBE\u7F6E\u4E3A\u9AD8\u4EAE\u8272\n  // \u800C\u8BBE\u7F6E .no-highlight \u7684\u8BDD\u5219\u53EF\u4EE5\u7981\u7528\u9AD8\u4EAE\u6548\u679C\uFF1B\n  tr:not(.no-highlight).highlight > td {\n    background: var(--highlight-bgcolor);\n  }\n\n  th {\n    font-weight: normal;\n    text-align: left;\n    padding: var(--cell-padding);\n    height: var(--header-row-height);\n    color: var(--header-color);\n    background: var(--header-bgcolor);\n    border:1px solid transparent;\n    border-right: var(--header-cell-border-vertical);\n    border-bottom: var(--header-cell-border-horizontal);\n    position: relative;\n  }\n\n  th.resizeable{\n    border-right: var(--header-cell-border-vertical)\n  }\n\n  th.", " {\n    border-right: var(--header-cell-border-vertical);\n    border-bottom: none;\n  }\n\n  tr.", " th {\n    border-top: var(--header-cell-border-horizontal);\n  }\n  th.", " {\n    border-left: var(--header-cell-border-vertical);\n  }\n\n  td {\n    padding: var(--cell-padding);\n    background: var(--bgcolor);\n    height: var(--row-height);\n    border:1px solid transparent;\n    border-right: var(--cell-border-vertical);\n    border-bottom: var(--cell-border-horizontal);\n    word-break: break-all;\n  }\n  td.", " {\n    border-left: var(--cell-border-vertical);\n  }\n  tr.", " td {\n    border-top: var(--cell-border-horizontal);\n  }\n  &.has-header tbody tr.", " td {\n    border-top: none;\n  }\n  &.has-footer tbody tr.", " td {\n    border-bottom: none;\n  }\n\n  .", ",\n  .", " {\n    z-index: ", ";\n  }\n\n  //#region \u9501\u5217\u9634\u5F71\n  .", " {\n    position: absolute;\n    top: 0;\n    bottom: 0;\n    z-index: ", ";\n    pointer-events: none;\n    overflow: hidden;\n\n    .", " {\n      height: 100%;\n    }\n\n    .", " {\n      margin-right: ", "px;\n      box-shadow: none;\n\n      &.show-shadow {\n        box-shadow: var(--lock-shadow);\n        border-right: var(--cell-border-vertical);\n      }\n    }\n\n    .", " {\n      margin-left: ", "px;\n      box-shadow: none;\n\n      &.show-shadow {\n        box-shadow: var(--lock-shadow);\n        border-left: var(--cell-border-vertical);\n      }\n    }\n  }\n  //#endregion\n\n  //#region \u7A7A\u8868\u683C\u5C55\u73B0\n  .", " {\n    pointer-events: none;\n    color: #99a3b3;\n    font-size: 12px;\n    text-align: center;\n    position: absolute;\n    left: 50%;\n    top: 50%;\n    transform: translate(-50%, -50%);\n\n    .empty-image {\n      width: 50px;\n      height: 50px;\n    }\n\n    .empty-tips {\n      margin-top: 16px;\n      line-height: 1.5;\n    }\n  }\n  //#endregion\n\n  //#region IE\u517C\u5BB9\n  &.ie-polyfill-wrapper {\n    //\u9501\u5B9A\u5217\u517C\u5BB9 \u4EC5\u5728\u9501\u5B9A\u5217\u7684\u60C5\u51B5\u4E0B\u751F\u6548\n    .", " {\n      overflow-x: hidden;\n    }\n    .", ", .", " {\n      position:relative;\n    }\n    .", " {\n      overflow: hidden;\n      display: flex;\n    }\n    .", " {\n      position: relative;\n    }\n\n    .", " {\n      display: flex;\n      overflow: auto;\n      overflow-x: hidden;\n      overflow-anchor: none;\n    }\n\n    .", ", .", "{\n      position: absolute;\n      z-index: ", ";\n      top: 0;\n    }\n    .", "{\n      left:0;\n    }\n    .", "{\n      right:0;\n    }\n\n    .", "{\n      .", "{\n        position: absolute;\n        top: 0;\n        width: 100%;\n        z-index: ", ";\n      }\n    }\n\n    tr:not(.no-hover).row-hover > td {\n      background: var(--hover-bgcolor);\n    }\n  }\n  //#endregion\n\n  //#region \u7C98\u6027\u6EDA\u52A8\u6761\n  .", "{\n    display:flex;\n    background: var(--bgcolor);\n  }\n  .", "{\n    height: 1px;\n    flex-shrink: 0;\n    border-top: 1px solid var(--border-color);\n  }\n\n  .", "{\n    height: 1px;\n    flex-shrink: 0;\n    border-top: 1px solid var(--border-color);\n  }\n  .", " {\n    overflow-y: hidden;\n    overflow-x: auto;\n    z-index: ", ";\n    flex-shrink: 1;\n    flex-grow: 0;\n    border-top: 1px solid var(--border-color);\n  }\n\n  .", " {\n    // \u5FC5\u987B\u6709\u9AD8\u5EA6\u624D\u80FD\u51FA\u73B0\u6EDA\u52A8\u6761\n    height: 1px;\n    visibility: hidden;\n  }\n  //#endregion\n\n  //#region \u52A0\u8F7D\u6837\u5F0F\n  .", " {\n    position: relative;\n    width: 100%;\n    height: 100%;\n    overflow: auto;\n\n    .", " {\n      filter: none;\n      width: 100%;\n      height: 100%;\n      overflow: hidden;//\u5217\u5168\u90E8\u56FA\u5B9A\u65F6\uFF0C\u5B58\u5728\u53CC\u6A2A\u5411\u6EDA\u52A8\u6761\n      display: flex;\n      position: relative;\n      flex-direction: column;\n    }\n\n    .", " {\n      position: absolute;\n      left: 0;\n      right: 0;\n      top: 0;\n      bottom: 0;\n      pointer-events: none;\n    }\n\n    .", " {\n      position: sticky;\n      z-index: ", ";\n      transform: translateY(-50%);\n    }\n  }\n  //#endregion\n\n  //#region \u8868\u683C\u8FC7\u6EE4\n  .", " {\n    color:var(--icon-color);\n    &.active{\n      color:var(--primary-color);\n    }\n    padding: 6px 4px;\n    &:hover{\n      background-color: #e5e5e5;\n    }\n    &:focus {\n      outline: none\n    }\n  }\n  //#endregion\n\n  //#region \u8868\u683C\u6392\u5E8F\n  .", " {\n    color:var(--icon-color);\n    &.active{\n      color:var(--primary-color);\n    }\n  }\n  .", " {\n    color:var(--icon-color);\n    &.active{\n      color:var(--primary-color);\n    }\n  }\n  //#endregion\n\n  //#region \u6EDA\u52A8\u6761\u5360\u4F4D\n  .", " {\n    visibility: hidden;\n    flex-shrink: 0;\n  }\n  .", " .", " {\n    border-top: var(--cell-border-horizontal);\n  }\n  //#endregion\n\n  //#region \u62D6\u62FD\u5217\u5BBD\u5927\u5C0F\n  .", "::after{\n    background-color: var(--border-color);\n  }\n  //\u89E3\u51B3\u90E8\u5206\u6D4F\u89C8\u5668(chrome109)\u6700\u540E\u4E00\u4E2A\u5355\u5143\u683C\u7684\u5217\u5BBD\u62D6\u62FD\u533A\u57DF\u7EDD\u5BF9\u5B9A\u4F4D\u8D85\u51FA\u8868\u683C\uFF0C\u5BFC\u81F4\u8868\u683C\u7AD6\u5206\u5272\u7EBF\u65E0\u6CD5\u5BF9\u9F50\n  .", " th.", " .", "{\n    right: 0;\n    width: 5px;\n    &::after{\n      left: 4px;\n    }\n  }\n  //#endregion\n\n  "])), variableConst, variableConst, outerBorderStyleMixin, Classes.artTableBordered, notBorderedStyleMixin, Classes.artTableBordered, borderedStyleMixin, Classes.artTable, Classes.tableHeader, Classes.tableHeaderCellContent, Classes.virtual, Classes.tableFooter, Classes.tableBody, Classes.tableFooter, Classes.tableRow, Classes.tableBody, Classes.tableFooter, Classes.tableCellRangeSelected, Classes.tableCellRangeTop, Classes.tableCellRangeLeft, Classes.tableCellRangeBottom, Classes.tableCellRangeRight, Classes.rangeSelection, Classes.rowDragging, Classes.tableBody, Classes.tableRow, Classes.tableFooter, Classes.tableRow, Classes.rowDragStart, Classes.rowDragEndToTop, Classes.rowDragEndToBottom, Classes.rowDragCell, Classes.tableHeader, Z.header, Classes.tableFooter, Z.footer, Classes.leaf, Classes.first, Classes.first, Classes.first, Classes.first, Classes.first, Classes.last, Classes.lockLeft, Classes.lockRight, Z.lock, Classes.lockShadowMask, Z.lockShadow, Classes.lockShadow, Classes.leftLockShadow, LOCK_SHADOW_PADDING, Classes.rightLockShadow, LOCK_SHADOW_PADDING, Classes.emptyWrapper, Classes.virtual, Classes.tableBody, Classes.tableFooter, Classes.tableHeaderMain, Classes.tableHeader, Classes.tableFooterMain, Classes.fixedLeft, Classes.fixedRight, Z.lock, Classes.fixedLeft, Classes.fixedRight, Classes.rowDetailContainer, Classes.rowDetailItem, Z.rowDetail, Classes.horizontalStickyScrollContainer, Classes.horizontalScrollLeftSpacer, Classes.horizontalScrollRightSpacer, Classes.stickyScroll, Z.scrollItem, Classes.stickyScrollItem, Classes.loadingWrapper, Classes.loadingContentWrapper, Classes.loadingIndicatorWrapper, Classes.loadingIndicator, Z.loadingIndicator, Classes.tableFilterTrigger, Classes.tableSortIcon, Classes.tableExtendIcon, Classes.verticalScrollPlaceholder, Classes.tableFooter, Classes.verticalScrollPlaceholder, Classes.tableHeaderCellResize, Classes.tableHeaderRow, Classes.last, Classes.tableHeaderCellResize);
export var ButtonCSS = css(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  ", "\n  //#region \u6309\u94AE\n  .", "{\n    color: var(--color);\n    background:#ffffff;\n    border:1px solid var(--strong-border-color);\n    border-radius: 2px;\n    cursor: pointer;\n    &:hover{\n      color: var(--primary-color);\n      border:1px solid var(--primary-color);\n    }\n  }\n  .", " {\n    color:#ffffff;\n    background-color: var(--primary-color);\n    border:none;\n    &:hover{\n      color:#ffffff;\n      background-color: var(--primary-color-level2);\n      border:none;\n    }\n  }\n//#endregion\n"])), variableConst, Classes.button, Classes.buttonPrimary);

function getCssVariableText(obj) {
  return _Object$keys(obj).reduce(function (acc, key) {
    var _context;

    acc += _concatInstanceProperty(_context = "".concat(key, ":")).call(_context, obj[key], ";");
    return acc;
  }, '');
}