"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCompProps = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/extends"));

var _compDefaultProps = _interopRequireDefault(require("../config-provider/compDefaultProps"));

// kd-ui提供组件默认属性

/**
 * 结合compDefaultProps、用户自定义默认属性和组件当前属性获取组件实际应用属性
 * @param {keyof typeof compDefaultProps} compName 组件名
 * @param {any} userDefaultProps 用户自定义组件默认属性
 * @param {any} compProps 组件接收到的属性
 */
var getCompProps = function getCompProps(compName, userDefaultProps, compProps) {
  var defaultProps = _compDefaultProps.default[compName];
  var userProps = userDefaultProps && userDefaultProps[compName] || {};
  return (0, _extends2.default)({}, defaultProps, userProps, compProps || {});
};

exports.getCompProps = getCompProps;