/// <reference types="react" />
import { RenderInfo } from './interfaces';
import { BaseTableProps } from './table';
export interface HtmlTableProps extends Required<Pick<BaseTableProps, 'getRowProps' | 'primaryKey'>> {
    tbodyHtmlTag: 'tbody' | 'tfoot';
    data: any[];
    stickyRightOffset?: number;
    horizontalRenderInfo: Pick<RenderInfo, 'flat' | 'visible' | 'horizontalRenderRange' | 'stickyLeftMap' | 'stickyRightMap'>;
    verticalRenderInfo: {
        offset: number;
        first: number;
        last: number;
        limit: number;
    };
    tbodyPosition?: 'left' | 'center' | 'right';
}
export declare function HtmlTable({ tbodyHtmlTag, getRowProps, primaryKey, stickyRightOffset, data, verticalRenderInfo: verInfo, horizontalRenderInfo: hozInfo, tbodyPosition }: HtmlTableProps): JSX.Element;
