export declare const LOCK_SHADOW_PADDING = 20;
export declare const Classes: {
    /** BaseTable 表格组件的外层包裹 div */
    readonly artTableWrapper: string;
    readonly artTableBordered: string;
    readonly artTable: string;
    readonly tableHeaderMain: string;
    readonly tableHeader: string;
    readonly tableBody: string;
    readonly virtual: string;
    readonly tableFooter: string;
    readonly tableFooterMain: string;
    /** 表格行 */
    readonly tableRow: string;
    /** 表头行 */
    readonly tableHeaderRow: string;
    /** 单元格 */
    readonly tableCell: string;
    /** 表头的单元格 */
    readonly tableHeaderCell: string;
    readonly tableHeaderCellContent: string;
    readonly tableHeaderCellResize: string;
    readonly virtualBlank: string;
    readonly stickyScroll: string;
    readonly stickyScrollItem: string;
    readonly horizontalScrollContainer: string;
    readonly verticalScrollPlaceholder: string;
    readonly horizontalStickyScrollContainer: string;
    readonly horizontalScrollLeftSpacer: string;
    readonly horizontalScrollRightSpacer: string;
    readonly lockShadowMask: string;
    readonly lockShadow: string;
    readonly leftLockShadow: string;
    readonly rightLockShadow: string;
    /** 数据为空时表格内容的外层 div */
    readonly emptyWrapper: string;
    readonly loadingWrapper: string;
    readonly loadingContentWrapper: string;
    readonly loadingIndicatorWrapper: string;
    readonly loadingIndicator: string;
    readonly tableHeaderCellLine: string;
    readonly tableFilterTrigger: string;
    readonly tableSortIcon: string;
    readonly tableExtendIcon: string;
    readonly button: string;
    readonly buttonPrimary: string;
    readonly filterIcon: string;
    readonly rangeSelection: string;
    readonly tableCellRangeSingleCell: string;
    readonly tableCellRangeSelected: string;
    readonly tableCellRangeTop: string;
    readonly tableCellRangeLeft: string;
    readonly tableCellRangeBottom: string;
    readonly tableCellRangeRight: string;
    readonly fixedLeft: string;
    readonly fixedRight: string;
    readonly rowDetailContainer: string;
    readonly rowDetailItem: string;
    readonly emptyColCell: string;
    readonly first: string;
    readonly last: string;
    readonly even: string;
    readonly odd: string;
    readonly lockLeft: string;
    readonly lockRight: string;
    readonly rowSpan: string;
    readonly leaf: string;
    readonly expanded: string;
    readonly collapsed: string;
    readonly popup: string;
    readonly popupHeader: string;
    readonly popupBody: string;
    readonly rowDragging: string;
    readonly rowDragStart: string;
    readonly rowDragEnd: string;
    readonly rowDragEndToTop: string;
    readonly rowDragEndToBottom: string;
    readonly rowDragElement: string;
    readonly rowDragCell: string;
};
export declare const MenuClasses: {
    menu: string;
    menuList: string;
    menuOption: string;
    menuOptionActive: string;
    menuOptionDisable: string;
    menuOptionText: string;
};
export declare type BaseTableCSSVariables = Partial<{
    /** 表格一行的高度，注意该属性将被作为 CSS variable，不能使用数字作为简写 */
    '--row-height': string;
    /** 表格的字体颜色 */
    '--color': string;
    /** 表格背景颜色 */
    '--bgcolor': string;
    /** 鼠标悬停时的背景色 */
    '--hover-bgcolor': string;
    /** 单元格高亮时的背景色 */
    '--highlight-bgcolor': string;
    /** 主题色 */
    '--primary-color': string;
    /** 主题色浅色1，浅色选中、悬浮 */
    '--primary-color-level1': string;
    /** 主题色浅色2，深色选中、悬浮 */
    '--primary-color-level2': string;
    /**图标默认颜色 */
    '--icon-color': string;
    /**边框颜色 */
    '--strong-border-color': string;
    /** 表头中一行的高度，注意该属性将被作为 CSS variable，不能使用数字作为简写 */
    '--header-row-height': string;
    /** 表头中的字体颜色 */
    '--header-color': string;
    /** 表头的背景色 */
    '--header-bgcolor': string;
    /** 表头上鼠标悬停时的背景色 */
    '--header-hover-bgcolor': string;
    /** 表头上单元格高亮时的背景色 */
    '--header-highlight-bgcolor': string;
    /** 单元格 padding */
    '--cell-padding': string;
    /** 字体大小 */
    '--font-size': string;
    /** 表格内字体的行高 */
    '--line-height': string;
    /** 锁列阴影，默认为 rgba(152, 152, 152, 0.5) 0 0 6px 2px */
    '--lock-shadow': string;
    /** 单元格的边框颜色 */
    '--border-color': string;
    /** 单元格边框，默认为 1px solid #dfe3e8 */
    '--cell-border': string;
    /** 单元格上下边框，默认为 none ，默认值为 1px solid #dfe3e8 */
    '--cell-border-horizontal': string;
    /** 单元格左右边框，默认为 #dfe3e8 */
    '--cell-border-vertical': string;
    /** 表头单元格边框，默认为 1px solid #dfe3e8 */
    '--header-cell-border': string;
    /** 表头单元格上下边框，默认为 none ，默认值为 1px solid #dfe3e8 */
    '--header-cell-border-horizontal': string;
    /** 表头单元格左右边框，默认为 1px solid #dfe3e8 */
    '--header-cell-border-vertical': string;
}>;
export declare const defaultCSSVariables: {
    '--row-height': string;
    '--color': string;
    '--bgcolor': string;
    '--hover-bgcolor': string;
    '--highlight-bgcolor': string;
    '--primary-color': string;
    '--primary-color-level1': string;
    '--primary-color-level2': string;
    '--icon-color': string;
    '--strong-border-color': string;
    '--header-row-height': string;
    '--header-color': string;
    '--header-bgcolor': string;
    '--header-hover-bgcolor': string;
    '--header-highlight-bgcolor': string;
    '--cell-padding': string;
    '--font-size': string;
    '--line-height': string;
    '--lock-shadow': string;
    '--border-color': string;
    '--cell-border': string;
    '--cell-border-horizontal': string;
    '---cell-border-vertical': string;
    '--header-cell-border': string;
    '--cell-border-vertical': string;
    '--header-cell-border-horizontal': string;
    '--header-cell-border-vertical': string;
};
export declare const variableConst: string;
export declare const StyledArtTableWrapper: any;
export declare const ButtonCSS: any;
