"use strict";

var _sliceInstanceProperty2 = require("@babel/runtime-corejs3/core-js-stable/instance/slice");

var _Array$from = require("@babel/runtime-corejs3/core-js-stable/array/from");

var _Symbol = require("@babel/runtime-corejs3/core-js-stable/symbol");

var _getIteratorMethod = require("@babel/runtime-corejs3/core-js/get-iterator-method");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = makeRecursiveMapper;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/extends"));

var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));

var _isLeafNode = _interopRequireDefault(require("./isLeafNode"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { var _context; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty2(_context = Object.prototype.toString.call(o)).call(_context, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function makeRecursiveMapper(fn) {
  return function (tree) {
    return dfs(tree, 0, []).result;

    function dfs(nodes, parentStartIndex, path) {
      var flatCount = 0;
      var result = [];

      var _iterator = _createForOfIteratorHelper(nodes),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var node = _step.value;
          path.push(node);
          var startIndex = parentStartIndex + flatCount;
          var subResult = void 0;

          if ((0, _isLeafNode.default)(node)) {
            subResult = fn(node, {
              // parentStartIndex,
              startIndex: startIndex,
              endIndex: startIndex + 1,
              path: (0, _slice.default)(path).call(path),
              isLeaf: true
            });
            flatCount += 1;
          } else {
            var dfsResult = dfs(node.children, startIndex, path);
            subResult = fn((0, _extends2.default)((0, _extends2.default)({}, node), {
              children: dfsResult.result
            }), {
              startIndex: startIndex,
              endIndex: startIndex + dfsResult.flatCount,
              path: (0, _slice.default)(path).call(path),
              isLeaf: false
            });
            flatCount += dfsResult.flatCount;
          }

          if (Array.isArray(subResult)) {
            result.push.apply(result, (0, _toConsumableArray2.default)(subResult));
          } else if (subResult != null) {
            result.push(subResult);
          }

          path.pop();
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return {
        result: result,
        flatCount: flatCount
      };
    }
  };
}